<<<<<<< aero-program.tcl
##
## filename is where we write the binary data
##

set bootldrfilename "i:/mobile/jamey/v0bootldr/bootldr"
set bootldrfilename "i:/linux/boot_loader/blob/blob2"
set bootldrfilename "i:/mobile/jamey/ohh/bootldr/bootldr"
set bootldrfilename "c:/corelis/bootldr"
set bootldrfilename "c:/skiff/bootldr-0000-2.9.5"

## load the DLL defining our new commands for programming flash
load Debug/Corelis.dll

## corelis.tcl defines some useful constants
source corelis.tcl
source flash-utils.tcl
source intelflash.tcl

##

set_scan_clk $OSC_30MHZ $CLK_DIV_BY_32
set_scan_clk $OSC_30MHZ $CLK_DIV_BY_16
set_scan_clk $OSC_30MHZ $CLK_DIV_BY_8
set_scan_clk $OSC_30MHZ $CLK_DIV_BY_4
set_scan_clk $OSC_40MHZ $CLK_DIV_BY_4

proc doubleword {w} {
    set d [expr ($w << 16) | $w]
    return $d
}
hard_reset 0



## query flash
set addr 0x0
set limit 0x200000

set idcode  [read_idcode]
puts "Idcode=$idcode"
aero_write_egpio 0x09000000 255 0x1f
aero_write_egpio 0x09000000 0 0x1f
aero_write_egpio 0x09000000 255 0x1f
aero_write_egpio 0x09000000 0 0x1f
aero_write_egpio 0x09000000 255 0x1f


if {0 == 1} {
    set iaddr 0
    set ilimit [expr 64 * 1024]
    while {$iaddr < $ilimit} {
	puts [format "\t %08x %08x" $iaddr [aero_read_flash $iaddr]]
	incr iaddr 4
    }
    puts "============================================================"
}

## put flash in query mode
aero_write_flash [expr 0x55 << 2] [doubleword 0x98]
aero_write_flash [expr 0x55 << 2] [doubleword 0x98]
set val1 [aero_read_flash [expr 0x00 << 2]]
if {$val1 != 0x00890089} {
    puts "Please reset board and try again: query flash returned $val1"
    exit -1
}

puts "0x00:"
puts [format "\t 0x%08x" [aero_read_flash [expr 0x00 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x01 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x02 << 2]]]

puts "0x10:"
puts [format "\t 0x%08x" [aero_read_flash [expr 0x10 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x11 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x12 << 2]]]

puts "0x30:"
puts [format "\t 0x%08x" [aero_read_flash [expr 0x30 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x31 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x32 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x33 << 2]]]

## reset flash to read mode
puts [aero_write_flash [expr 0x55 << 2] [doubleword 0xF0]]
puts [aero_write_flash [expr 0x55 << 2] [doubleword 0xF0]]

puts [aero_write_flash [expr 0x55 << 2] [doubleword 0xFF]]
puts [aero_write_flash [expr 0x55 << 2] [doubleword 0xFF]]

puts "reading 0x00:"
puts [format "\t 0x%08x" [aero_read_flash [expr 0x00 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x01 << 2]]]

## clear block lock bits
aero_write_flash 0 [doubleword 0x60] 
aero_write_flash 0 [doubleword 0xd0] 

# puts "erasing block 0"
# eraseFlashSector 0x0

programFlashFromFile $bootldrfilename 0 {} 0

aero_write_flash 0 [doubleword 0xFF]
aero_write_flash 0 [doubleword 0xFF]
aero_write_flash 0 [doubleword 0xFF]
aero_write_flash 0 [doubleword 0xFF]

# hard_reset 0
=======
##
## filename is where we write the binary data
##

set bootldrfilename "i:/mobile/jamey/v0bootldr/bootldr"
set bootldrfilename "i:/linux/boot_loader/blob/blob2"
set bootldrfilename "i:/mobile/jamey/ohh/bootldr/bootldr"
set bootldrfilename "c:/corelis/bootldr"
##set bootldrfilename "c:/skiff/bootldr-0000-2.14.8"
set bootldrfilename "c:/skiff/bootldr-0000-2.9.5"

## load the DLL defining our new commands for programming flash
load Debug/Corelis.dll

## corelis.tcl defines some useful constants
source corelis.tcl
source flash-utils.tcl
source intelflash.tcl

##

set_scan_clk $OSC_30MHZ $CLK_DIV_BY_32
set_scan_clk $OSC_30MHZ $CLK_DIV_BY_16
set_scan_clk $OSC_30MHZ $CLK_DIV_BY_8
set_scan_clk $OSC_30MHZ $CLK_DIV_BY_4
set_scan_clk $OSC_40MHZ $CLK_DIV_BY_4

proc doubleword {w} {
    set d [expr ($w << 16) | $w]
    return $d
}
hard_reset 0



## query flash
set addr 0x0
set limit 0x200000

set idcode  [read_idcode]
puts "Idcode=$idcode"

proc enable_vpp {} {
    aero_write_egpio 0x49000000 255 0x1f
}

if {0 == 1} {
    set iaddr 0
    set ilimit [expr 64 * 1024]
    while {$iaddr < $ilimit} {
	puts [format "\t %08x %08x" $iaddr [aero_read_flash $iaddr]]
	incr iaddr 4
    }
    puts "============================================================"
}

## put flash in query mode
aero_write_flash [expr 0x55 << 2] [doubleword 0x98]
aero_write_flash [expr 0x55 << 2] [doubleword 0x98]
set val1 [aero_read_flash [expr 0x00 << 2]]
if {$val1 != 0x00890089} {
    puts "Please reset board and try again: query flash returned $val1"
    exit -1
}

puts "0x00:"
puts [format "\t 0x%08x" [aero_read_flash [expr 0x00 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x01 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x02 << 2]]]

puts "0x10:"
puts [format "\t 0x%08x" [aero_read_flash [expr 0x10 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x11 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x12 << 2]]]

puts "0x30:"
puts [format "\t 0x%08x" [aero_read_flash [expr 0x30 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x31 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x32 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x33 << 2]]]

## reset flash to read mode
puts [aero_write_flash [expr 0x55 << 2] [doubleword 0xF0]]
puts [aero_write_flash [expr 0x55 << 2] [doubleword 0xF0]]

puts [aero_write_flash [expr 0x55 << 2] [doubleword 0xFF]]
puts [aero_write_flash [expr 0x55 << 2] [doubleword 0xFF]]

puts "reading 0x00:"
puts [format "\t 0x%08x" [aero_read_flash [expr 0x00 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x01 << 2]]]

## reset
aero_write_flash 0 [doubleword 0xFF] 
aero_write_flash 0 [doubleword 0xF0] 

## clear block lock bits
enable_vpp
puts "Clearing block lock bits"
aero_write_flash 0 [doubleword 0x60] 
aero_write_flash 0 [doubleword 0xd0] 

puts "Checking status"
puts [format "\t 0x%08x" [aero_read_flash [expr 0x00 << 2]]]
puts [format "\t 0x%08x" [aero_read_flash [expr 0x01 << 2]]]

aero_write_flash 0 [doubleword 0xFF] 
aero_write_flash 0 [doubleword 0xF0] 

## reset
aero_write_flash 0 [doubleword 0xFF] 

# puts "erasing block 0"
# eraseFlashSector 0x0

programFlashFromFile $bootldrfilename 0 {} 0

aero_write_flash 0 [doubleword 0xFF]
aero_write_flash 0 [doubleword 0xFF]
aero_write_flash 0 [doubleword 0xFF]
aero_write_flash 0 [doubleword 0xFF]

# hard_reset 0
>>>>>>> 1.4
